com.fasterxml.jackson.databind.deser.std

## Class EnumDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<Object>
      - - com.fasterxml.jackson.databind.deser.std.EnumDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, NullValueProvider, Serializable

      public class EnumDeserializer
      extends StdScalarDeserializer<Object>
      implements ContextualDeserializer

  Deserializer class that can deserialize instances of specified Enum class from Strings and Integers.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Boolean` | `_caseInsensitive`
    `protected Object[]` | `_enumsByIndex`
    `protected CompactStringObjectMap` | `_lookupByName`
    `protected CompactStringObjectMap` | `_lookupByToString` Alternatively, we may need a different lookup object if "use toString" is defined.

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `EnumDeserializer(EnumDeserializer base, Boolean caseInsensitive)`
    `` | `EnumDeserializer(EnumResolver byNameResolver)` Deprecated. Since 2.9
    `` | `EnumDeserializer(EnumResolver byNameResolver, Boolean caseInsensitive)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Object` | `_deserializeOther(JsonParser p, DeserializationContext ctxt)`
    `protected Class<?>` | `_enumClass()`
    `protected CompactStringObjectMap` | `_getToStringLookup(DeserializationContext ctxt)`
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
    `Object` | `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `static JsonDeserializer<?>` | `deserializerForCreator(DeserializationConfig config, Class<?> enumClass, AnnotatedMethod factory)` Deprecated. Since 2.8
    `static JsonDeserializer<?>` | `deserializerForCreator(DeserializationConfig config, Class<?> enumClass, AnnotatedMethod factory, ValueInstantiator valueInstantiator, SettableBeanProperty[] creatorProps)` Factory method used when Enum instances are to be deserialized using a creator (static factory method)
    `static JsonDeserializer<?>` | `deserializerForNoArgsCreator(DeserializationConfig config, Class<?> enumClass, AnnotatedMethod factory)` Factory method used when Enum instances are to be deserialized using a zero-/no-args factory method
    `boolean` | `isCachable()` Because of costs associated with constructing Enum resolvers, let's cache instances by default.
    `EnumDeserializer` | `withResolved(Boolean caseInsensitive)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer

      `deserialize, deserializeWithType, getEmptyAccessPattern, getNullAccessPattern, supportsUpdate`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueType, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserializeWithType, findBackReference, getDelegatee, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _enumsByIndex

          protected Object[] _enumsByIndex

    - #### _lookupByName

          protected final CompactStringObjectMap _lookupByName

      Since:
        2.7.3

    - #### _lookupByToString

          protected CompactStringObjectMap _lookupByToString

      Alternatively, we may need a different lookup object if "use toString" is defined.
      Since:
        2.7.3

    - #### _caseInsensitive

          protected final Boolean _caseInsensitive

  - ### Constructor Detail

    - #### EnumDeserializer

          public EnumDeserializer(EnumResolver byNameResolver,
                                  Boolean caseInsensitive)

      Since:
        2.9

    - #### EnumDeserializer

          protected EnumDeserializer(EnumDeserializer base,
                                     Boolean caseInsensitive)

      Since:
        2.9

    - #### EnumDeserializer

          @Deprecated
          public EnumDeserializer(EnumResolver byNameResolver)

      Deprecated. Since 2.9

  - ### Method Detail

    - #### deserializerForCreator

          @Deprecated
          public static JsonDeserializer<?> deserializerForCreator(DeserializationConfig config,
                                                                               Class<?> enumClass,
                                                                               AnnotatedMethod factory)

      Deprecated. Since 2.8

    - #### deserializerForCreator

          public static JsonDeserializer<?> deserializerForCreator(DeserializationConfig config,
                                                                   Class<?> enumClass,
                                                                   AnnotatedMethod factory,
                                                                   ValueInstantiator valueInstantiator,
                                                                   SettableBeanProperty[] creatorProps)

      Factory method used when Enum instances are to be deserialized using a creator (static factory method)
      Returns:
        Deserializer based on given factory method
      Since:
        2.8

    - #### deserializerForNoArgsCreator

          public static JsonDeserializer<?> deserializerForNoArgsCreator(DeserializationConfig config,
                                                                         Class<?> enumClass,
                                                                         AnnotatedMethod factory)

      Factory method used when Enum instances are to be deserialized using a zero-/no-args factory method
      Returns:
        Deserializer based on given no-args factory method
      Since:
        2.8

    - #### withResolved

          public EnumDeserializer withResolved(Boolean caseInsensitive)

      Since:
        2.9

    - #### createContextual

          public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                      BeanProperty property)
                                               throws JsonMappingException

      Description copied from interface: `ContextualDeserializer`
      Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### isCachable

          public boolean isCachable()

      Because of costs associated with constructing Enum resolvers, let's cache instances by default.
      Overrides:
        `isCachable` in class `JsonDeserializer<Object>`

    - #### deserialize

          public Object deserialize(JsonParser p,
                                    DeserializationContext ctxt)
                             throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (p.currentToken() == JsonToken.START_OBJECT) {
                   p.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Object>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### _deserializeOther

          protected Object _deserializeOther(JsonParser p,
                                             DeserializationContext ctxt)
                                      throws IOException

      Throws:
        `IOException`

    - #### _enumClass

          protected Class<?> _enumClass()

    - #### _getToStringLookup

          protected CompactStringObjectMap _getToStringLookup(DeserializationContext ctxt)

Copyright © 2008–2019 FasterXML. All rights reserved.